<apex:component >
    <div class="containerBox fixed-column-table" fixed-columns="fixedColum" number-of-displayed-columns="12" ng-hide="items.length==0">
        <table aria-multiselectable="true" class="table-example" role="grid">
            <thead>
                <tr>
                    <th style="width:20px;" ng-if="disableCheckBox==false &&selectedPosLevel=='1' && selectedPositionNode.original.RelatedPosType!='Overlay' && selectAllTerritory=='true'"><input id="selectAll" type="checkbox" onclick="selectAll();" /></th>
                    <th ng-if="selectAllTerritory=='false' || disableCheckBox==true"></th>
                    <th ng-repeat="column in columnName" class="col-resizer slds-truncate">
                        <a ng-click="sort(column[updateNameSpace('Attribute_API_Name__c')])" title="{{column[updateNameSpace('Attribute_Display_Name__c')]}}">
                            <i class="{{(sortKey != column[updateNameSpace('Attribute_API_Name__c')])?'fas fa-sort':(reverse)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>
                            &nbsp;&nbsp;&nbsp;{{column[updateNameSpace('Attribute_Display_Name__c')]}}
                        </a>
                    </th>
                    <th ng-if="selectedPosLevel=='1' && movementType == '{!$Label.Account}' && !restrictAccountAffiliation">{!$Label.View_Hierarchy}</th>
                </tr>
            </thead>
            <tbody>
                <tr dir-paginate="item in items|arcOrderBy:sortKey:!reverse|searchfilter:searchListView|itemsPerPage:tableHeight" class="{{item['isChecked']?'highlight':''}}" pagination-id="tableView">
                    <td ng-if="selectedPosLevel=='1' && movementType == '{!$Label.ZIP}' && selectedPositionNode.original.RelatedPosType!='Overlay'"><input type="checkbox" class="getCheckbox" ng-disabled="(item[geoParentAPIName]!=null && item[geoParentAPIName]!='')  || item[changeStatusAPI]=='Pending' || item[changeStatusAPI]=='Submission Pending' || item['isDisabled']" value="{{item[geoNameAPIName]}}" onclick="selectParent(this.value)" ng-checked="item['isChecked']" />
                    </td>
                    <td ng-if="selectedPosLevel=='1' && movementType == '{!$Label.Account}' && selectedPositionNode.original.RelatedPosType!='Overlay'"><input type="checkbox" class="getCheckbox" value="{{item[accountNumberAPIName]}}" ng-disabled="item[changeStatusAPI]=='Pending' || item[changeStatusAPI]=='Submission Pending' || item['isDisabled']" onclick="selectAccount(this.value)" ng-checked="item['isChecked']" />
                    </td>
                    <td ng-if="key!='isChecked' && key!='isDisabled'" ng-repeat="(key,value) in item" class="slds-truncate">
                        <span ng-show="(value|lowercase) != 'pending' && (value|lowercase) != 'submission pending' && (value|lowercase)!='no change' && (value|lowercase) != 'rejected' && (value|lowercase) != 'cancelled' && (value|lowercase) != 'approved' " title="{{value}}">{{value}}</span>
                        <span ng-show="(value|lowercase) == 'pending'"><a title="{!$Label.Approval_Pending}"><span class="sp-clock icon-svg saffron"></span><br /></a></span>
                        <span ng-show="(value|lowercase) =='submission pending'">
                            <a title="{!$Label.STATUS_SUBMISSION_PENDING}"><span class="sp-threedots icon-svg saffron"></span><br /></a>
                        </span>
                        <span ng-show="(value|lowercase) == 'no change' && (value|lowercase) == 'rejected' && (value|lowercase) == 'cancelled' && (value|lowercase) == 'approved'"><a title=""></a></span>
                    </td>
                    <td ng-if="selectedPosLevel=='1' && movementType == '{!$Label.Account}' && !restrictAccountAffiliation">
                        <span>
                            <a title='{!$Label.View_Hierarchy}' value="{{item[accountNumberAPIName]}}" onclick="openHierarchyCmp(this);"><span class="icon-nodes icon-svg biscay"></span></a>
                        </span>
                    </td>
                <tr ng-if="(items |searchfilter:searchListView).length == 0">
                    <td class="slds-text-align_center" colspan="{{noRecondFoundColSPan}}" style="background:#fff !important;border-bottom:none;">
                        <!-- Search Data not found in Data Table. -->
                        <c:NoRecordFoundComponent ErrorMessage="Search Data not found in Data Table." TooltipMessage="" />
                    </td>
                </tr>
                </tr>
            </tbody>
        </table>
    </div>
    <dir-pagination-controls max-size="7" direction-links="true" boundary-links="true" pagination-id="tableView"></dir-pagination-controls>
    <div ng-show="items.length==0" style="padding-top:120px;">
        <c:NoRecordFoundComponent ErrorMessage="Table Data not Exist, Please contact SalesIQ Administrator" TooltipMessage="" />
    </div>

    <script>
        var selectedPosId;
        var selectedMovementType;

        window.openHierarchyCmp = function(target) {
            var accountNumber = $(target).attr('value');
            var $scope = getScope('ARC');
            showAccountHierarchy(accountNumber, $scope.selectedCycle);
        }
        window.getScope = function(ctrlName) {
            var sel = 'div[ng-controller="' + ctrlName + '"]';
            return angular.element(sel).scope();
        }

        window.JSONToCSVConvertor = function(ReportTitle, ShowLabel) {
            var $scope = getScope('ARC');
            JSONData = $scope.items;
            //If JSONData is not an object then JSON.parse will parse the JSON string in an Object
            var arrData = typeof JSONData != 'object' ? JSON.parse(JSONData) : JSONData;

            var CSV = '';
            //Set Report title in first row or line

            CSV += ReportTitle + '\r\n\n';

            //1st loop is to extract each row
            for (var i = 0; i < arrData.length; i++) {
                var row = "";

                //2nd loop will extract each column and convert it in string comma-seprated
                for (var index in arrData[i]) {
                    row += '"' + arrData[i][index] + '",';
                }

                row.slice(0, row.length - 1);

                //add a line break after each row
                CSV += row + '\r\n';
            }

            if (CSV == '') {
                alert("Invalid data");
                return;
            }

            //Generate a file name
            var fileName = "MyReport_";
            //this will remove the blank-spaces from the title and replace it with an underscore
            fileName += ReportTitle.replace(/ /g, "_");

            //Initialize file format you want csv or xls
            var uri = 'data:text/csv;charset=utf-8,' + escape(CSV);

            // Now the little tricky part. you can use either>> window.open(uri); but this will not work in some browsers or you will not get the correct file extension    
            //this trick will generate a temp <a /> tag
            var link = document.createElement("a");
            link.href = uri;
            link.target = '_self';

            //set the visibility hidden so it will not effect on your web-layout
            link.style = "visibility:hidden";
            link.download = fileName + ".csv";

            //this part will append the anchor tag and remove it after automatic click
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        }

        window.selectParent = function(GeoCode) {
            var $scope = getScope('ARC');
            var counter = 0;
            // Settings check box for ZIPS value 'isChecked' according to oparation
            $scope.items.forEach(function(value, index) {
                // child selection 
                if (value[$scope.geoNameAPIName] == GeoCode) {
                    if ($scope.items[index]['isChecked'] == true) {
                        $scope.items[index]['isChecked'] = false;
                          if($scope.lightningMode){
                                if(selectedGeoRecordsBulk.has(GeoCode));
                                    selectedGeoRecordsBulk.delete(GeoCode);    
                         }
                    } else {
                        $scope.items[index]['isChecked'] = true;
                    }
                }
              
                // Parent selection 
                if (value[$scope.geoParentAPIName] == GeoCode) {
                    if ($scope.items[index]['isChecked'] == true) {
                        $scope.items[index]['isChecked'] = false;
                        if($scope.lightningMode){
                                if(selectedGeoRecordsBulk.has(value[$scope.geoNameAPIName]));
                                    selectedGeoRecordsBulk.delete(value[$scope.geoNameAPIName]);    
                         }
                    } else {
                        $scope.items[index]['isChecked'] = true;
                    }
                }
                if ($scope.items[index]['isChecked'] == true) {
                    counter++;
                }

            });
            $scope.numberOfSelectedCheckbox = counter;
            $scope.$apply();
        }

        window.selectAccount = function(accountCode) {
            //console.log("accountCode   -->" + accountCode);
            var $scope = getScope('ARC');
            var counter = 0;
            $scope.items.forEach(function(value, index) {
                if (value[$scope.accountNumberAPIName] == accountCode) {

                    if ($scope.items[index]['isChecked'] == true) {
                        $scope.items[index]['isChecked'] = false;
                    } else {
                        $scope.items[index]['isChecked'] = true;
                    }
                }
                if ($scope.items[index]['isChecked'] == true) {
                    counter++;
                }
            });
            $scope.numberOfSelectedCheckbox = counter;
            $scope.$apply();
        }

        // Select All function for select all checkbox
        window.selectAll = function() {
            var $scope = getScope('ARC');

            $scope.items.forEach(function(value, index) {
                if ($scope.items[index][$scope.changeStatusAPI] != 'Pending' && $scope.items[index][$scope.changeStatusAPI] != 'Submission Pending') {
                    if ($scope.isChecked == true) {
                        $scope.items[index]['isChecked'] = false;
                        $scope.numberOfSelectedCheckbox = 0;
                    } else {
                        $scope.items[index]['isChecked'] = true;
                        $scope.numberOfSelectedCheckbox = $('.getCheckbox').length;
                    }
                }
            });
            if ($scope.isChecked == false) {
                $scope.isChecked = true;

            } else {
                $scope.isChecked = false;
                selectedGeoRecordsBulk.clear();
            }
            $scope.$apply();
        }

        var relatedBasePosition;
        window.createDataTable = function() {
            console.log('createDataTable called : ' + selectedPosId);
            var $scope = getScope('ARC');
            var advanceSearchRerender = false;
            relatedBasePosition = '';
            var __sfdcSessionId = '{!GETSESSIONID()}';
            sforce.connection.sessionId = "{!$Api.Session_ID}";
            //Checking if there is need to refresh the advance search panel
            if (selectedPosId == undefined || selectedMovementType != $scope.movementType || selectedPosId != $scope.selectedPositionNode.original.key) {
                advanceSearchRerender = true;
            }
            
            selectedPosId = $scope.selectedPositionNode.original.key;
            selectedPositionCode = $scope.selectedPositionNode.id;
            var PosType = ReturnPositionType($scope.selectedPositionNode.original.RelatedPosType);
            $scope.disableCheckBox = false;
            
            if($scope.selectedPositionNode.original.Level == 1 && $scope.selectedPositionNode.original.RelatedPosType == 'Mirror'){
                
                //var assignmentstausSoql = generateAssignmentStatusSoql(); 
              	var soql = "select id ,"+ns+"Base_Position__c from "+ns+"Related_Position__c where "+ns+"Related_Position__c ='"+$scope.selectedPositionNode.original.key+"' ";
              	//soql = soql+assignmentstausSoql;
              	console.log('#### soql ' + soql);
              	var relatedPos = sforce.connection.query(soql);
              	var relatedPosArray = relatedPos.getArray("records");
              	console.log(relatedPos);
              	if(relatedPosArray.length > 0){
              		for(var j=0;j<relatedPosArray.length; j++){
              			if(relatedPosArray[j][ns+'Base_Position__c'] != undefined){
              				relatedBasePosition = relatedPosArray[j][ns+'Base_Position__c'];	
              			}
              		}
              	}
              	console.log(relatedBasePosition);
              	for (var pos in $scope.positionsData) {
              	        if($scope.positionsData[pos].original != undefined && $scope.positionsData[pos].original.key == relatedBasePosition){
              	            selectedPosId = $scope.positionsData[pos].original.key;
              	            selectedPositionCode = pos;
              	        }
              	    	
              	}
                PosType ='Base';
                $scope.disableCheckBox= true;
            } 

            $scope.isChecked = false;
            var selectColumns;
            $scope.selectedPosLevel = $scope.selectedPositionNode.original.Level;
            if ($scope.selectedPosLevel != 1) {
                $scope.fixedColum = $scope.selectedDataJson.defaulConfig.positionListFixedCols;
                //console.log('$scope.movementType listview');
                //console.log($scope.selectedPosLevel);
                console.log($scope.fixedColum);
            }
            selectedMovementType = $scope.movementType;
           
            var selectedCycle = $scope.selectedCycle;
            

            positionId = selectedPosId;
            


            var soql = '';
            var fetchColumnNames;
            fetchColumnNames = "Select " + ns + "Attribute_API_Name__c, " + ns + "Attribute_Display_Name__c, " + ns + "Data_Type__c From " + ns + "Team_Instance_Object_Attribute__c ";
            fetchColumnNames += "where " + ns + "isEnabled__c = True ";
            fetchColumnNames += "and " + ns + "Team_Instance__c = '" + selectedCycle + "' ";

            var interfaceName = '';
            if ($scope.selectedPosLevel == '1' && selectedMovementType == '{!$Label.ZIP}') {
                selectColumns = true;
                interfaceName = 'Zip Movement';
                fetchColumnNames += "and " + ns + "Interface_Name__c = \'Zip Movement\' ";
                //SIMPS:991,1120
                if($scope.isCIMavailable==false){
                    fetchColumnNames += "and " + ns + "data_type__c != \'Number\' ";
                }
            } else if ($scope.selectedPosLevel == '1' && selectedMovementType == '{!$Label.Account}') {
                selectColumns = true;
                interfaceName = 'Account Movement';
                fetchColumnNames += "and " + ns + "Interface_Name__c = \'Account Movement\' ";
                //SIMPS:991,1120
                if($scope.isCIMavailable==false){
                    fetchColumnNames += "and " + ns + "data_type__c != \'Number\' ";
                }
            } else {
                selectColumns = false;
                interfaceName = 'Position List View';
                fetchColumnNames += "and " + ns + "Interface_Name__c = \'Position List View\' ";
            }

            //Refresh advance search 
            if (advanceSearchRerender) {
                validJson = {};
                document.getElementById('advanceSearchPanel').style.display = 'none';
                reRenderAdvanceSearch(interfaceName, $scope.selectedCycle);
            }

            fetchColumnNames += "order by " + ns + "Display_Column_Order__c ";

            soql = 'select id, ';

            //console.log('Column soql : ' + fetchColumnNames);
            var getColumnsQueryResult = sforce.connection.query(fetchColumnNames);
            var columnNames = new Array();
            getColumns = getColumnsQueryResult.getArray("records");
            //console.log('columns');
            //console.log(getColumns);

            //To support localization
            getColumns.forEach(function(column) {
                column[ns + 'Attribute_Display_Name__c'] = $scope.selectedDataJson.defaulConfig.columnLabel[column[ns + 'Attribute_Display_Name__c']];
            });
            $scope.columnName = getColumns;

            var colVar = 0;
            $scope.geoNameAPIName = ns + 'Geography__r.Name';
            if (getColumns.length > 0) {
                for (var i = 0; i < getColumns.length; i++) {
                    if (getColumns[i][ns + 'Attribute_API_Name__c'] != null && getColumns[i][ns + 'Attribute_Display_Name__c'] != null) {
                        soql = soql + getColumns[i][ns + 'Attribute_API_Name__c'] + ',';
                        if (selectedMovementType == '{!$Label.Account}') {
                            if (getColumns[i][ns + 'Attribute_API_Name__c'].indexOf('AccountNumber') != -1)
                                $scope.accountNumberAPIName = getColumns[i][ns + 'Attribute_API_Name__c'];
                        } else {
                            if (getColumns[i][ns + 'Attribute_API_Name__c'].indexOf('Name') != -1 && getColumns[i][ns + 'Attribute_API_Name__c'].indexOf('Geography__r') != -1) {
                                $scope.geoNameAPIName = getColumns[i][ns + 'Attribute_API_Name__c'];
                            }
                            if (getColumns[i][ns + 'Attribute_API_Name__c'].indexOf('Parent_Zip__c') != -1) {
                                $scope.geoParentAPIName = getColumns[i][ns + 'Attribute_API_Name__c'];
                            }
                        }
                        if (getColumns[i][ns + 'Attribute_API_Name__c'].indexOf('Change_Status__c') != -1) {
                            $scope.changeStatusAPI = getColumns[i][ns + 'Attribute_API_Name__c'];
                        }
                    }
                }

                /*If level 1 position is selected and SharedWith__C is already not added in the query*/
                if ($scope.selectedPosLevel == 1 && soql.indexOf(ns + 'SharedWith__c') == -1) {
                    soql += ns + 'SharedWith__c,'
                }

                soql = soql.substring(0, soql.length - 1);

                if ($scope.selectedPosLevel == '1' && selectedMovementType == '{!$Label.ZIP}') {
                    soql = soql + "," + ns + "Assignment_Status__c, " + ns + "Team_Instance__r." + ns + "Alignment_Period__c  From " + ns + "Position_Geography__c Where  " + ns + "Team_Instance__c = '" + selectedCycle + "' and " + ns + "Position__c = '" + selectedPosId + "' and (" + ns + "Assignment_Status__c!=\'Inactive\' OR " + ns + "Past_Active__c = true) and " + ns + "Position__r." + ns + "Related_Position_Type__c = '" + PosType + "'";

                    soql += " Order By " + ns + "Effective_Start_Date__c limit " + $scope.selectedDataJson.defaulConfig.zipsToLoad_Table;
                    //Added order by for SPD-2700
                    //default Ordring will be acending 
                } else if ($scope.selectedPosLevel == '1' && selectedMovementType == '{!$Label.Account}') {
                    soql = soql + "," + ns + "Assignment_Status__c ," + ns + "Account__r.id," + ns + "Team_Instance__r." + ns + "Alignment_Period__c From " + ns + "Position_Account__c Where " + ns + "Team_Instance__c = '" + selectedCycle + "' and (" + ns + "Assignment_Status__c!=\'Inactive\' OR " + ns + "Past_Active__c = true) and  " + ns + "Position__c = '" + selectedPosId + "'";
                    soql += " Order By " + ns + "Effective_Start_Date__c limit " + $scope.selectedDataJson.defaulConfig.accountsToLoad_Table;
                } else {
                    var convergLevel = $scope.selectedDataJson.defaulConfig.convergingLevel;
                    var baseTeamInstanceId = $scope.selectedDataJson.defaulConfig.baseTeamInstanceId;

                    //if(layerSourceDetailsMap[selectedCycle]!=undefined)
                    //convergLevel = layerSourceDetailsMap[selectedCycle]['convergingLevel'];

                    console.log('convergLevel' + convergLevel);

                    if (convergLevel != undefined && convergLevel != 0) {
                        soql = soql + " From " + ns + "Position__c ";
                        soql += "where ((" + ns + "Team_Instance__c = '" + selectedCycle + "' AND " + ns + "Hierarchy_Level__c < '" + convergLevel + "' and  " + ns + "Related_Position_Type__c = '"+PosType+"') OR (" + ns + "Team_Instance__c = '" + baseTeamInstanceId + "' AND " + ns + "Hierarchy_Level__c >= '" + convergLevel + "' AND " + ns + "Related_Position_Type__c = 'Base'))" + " AND " + ns + "Parent_Position__c = '" + selectedPosId + "'";
                        soql += " AND " + ns + "inactive__c = False Order By Name ";
                    } else {
                        soql = soql + " From " + ns + "Position__c ";
                        soql += "where " + ns + "Team_Instance__c = '" + selectedCycle + "' and " + ns + "Parent_Position__c = '" + selectedPosId + "'";
                        soql += " and " + ns + "inactive__c = False and " + ns + "Related_Position_Type__c = '" + PosType + "' Order By Name ";
                    }
                }

                //Adding filters of advance search 
                if (soql.indexOf('Order By') != -1 && advanceSearchWhereClause != '') {
                    var soqlQueryArray = soql.split('Order By');
                    soql = soqlQueryArray[0] + ' AND ' + advanceSearchWhereClause + ' Order By ' + soqlQueryArray[1];
                }

                console.log('--soqlQueryArray ', soql);

                var callback = {
                    onSuccess: success,
                    onFailure: failure
                }
                $scope.tableSoql = soql;
                sforce.connection.batchSize = 2000;
                var result = [];
                FilterresultMap = [];

                var results = sforce.connection.query(soql, callback);
                var tableData = [];

                function success(results) {
                    var mapgeoPositionGeograpby = new Object();
                    //tableData.concat(results.getArray("records"));
                    var record = results.getArray("records");
                    for (i = 0; i < record.length; i++) {
                        tableData.push(record[i]);
                    }
                    if (results.queryLocator) {
                        sforce.connection.queryMore(results.queryLocator, callback);
                    } else {
                        console.log('table data');
                        console.log(tableData);
                        $scope.tableData = tableData;
                        var dataTable = [];
                        for (var i = 0; i < tableData.length; i++) {
                            var data = {};
                            data['isChecked'] = false;
                            data['isDisabled'] = false;

                            if ($scope.selectedPosLevel == '1') {
                                if($scope.disableCheckBox){
                                     data['isDisabled'] = true;
                                }
                                if (selectedMovementType == '{!$Label.ZIP}' && $scope.selectedDataJson.teamInstance[ns + 'Alignment_Period__c'] == 'Current') {
                                    if (tableData[i][ns + 'Assignment_Status__c'] == 'Future Active')
                                        data['isDisabled'] = true;

                                }

                                if (selectedMovementType == '{!$Label.Account}' && $scope.selectedDataJson.teamInstance[ns + 'Alignment_Period__c'] == 'Current') {
                                    if (tableData[i][ns + 'Assignment_Status__c'] == 'Future Active') {
                                        data['isDisabled'] = true;
                                    }

                                }
                                if (selectedMovementType == '{!$Label.ZIP}' && $scope.selectedGeoRecords != undefined && $scope.selectedGeoRecords.size > 0) {
                                    if ($scope.selectedGeoRecords.has(tableData[i][ns + 'Geography__r']['Name'])) {
                                        data['isChecked'] = true;
                                    }
                                } else if (selectedMovementType == '{!$Label.Account}' && $scope.selectedAccountRecords != undefined && $scope.selectedAccountRecords.size > 0) {
                                    if ($scope.selectedAccountRecords.has(tableData[i][ns + 'Account__r']['AccountNumber'])) {
                                        data['isChecked'] = true;
                                    }
                                }
                            }

                            for (var j = 0; j < getColumns.length; j++) {
                                if (getColumns[j][ns + 'Attribute_API_Name__c']) {
                                    var cellData;
                                    if ((getColumns[j][ns + 'Attribute_API_Name__c']).indexOf('.') > 0) {
                                        var attrName = getColumns[j][ns + 'Attribute_API_Name__c'].split('.');
                                        var temp = ""
                                        for (var k = 0; k < attrName.length; k++) {
                                            if (k == 0 && temp != undefined) {
                                                temp = tableData[i][attrName[k]];
                                            } else if (temp != undefined && temp != null) {
                                                temp = temp[attrName[k]];
                                            }
                                        }

                                        cellData = temp;
                                    } else {
                                        cellData = tableData[i][getColumns[j][ns + 'Attribute_API_Name__c']];
                                    }
                                    if (getColumns[j][ns + 'Data_Type__c'] == 'Date') {
                                        var date = new Date(cellData);
                                        var newDate = formatDate(date);
                                        data[getColumns[j][ns + 'Attribute_API_Name__c']] = newDate;
                                    } else if (getColumns[j][ns + 'Data_Type__c'] == 'Number') {
                                        var decimal = '0';
                                        if (cellData != '' && cellData != undefined) {
                                            var decialKPI = parseFloat(cellData);
                                            var formatKpi  =  decialKPI.toFixed(parseInt($scope.selectedDataJson.defaulConfig.metricsDecimalConfig));
                                            //var formatKpi = Math.round(decialKPI);

                                            decimal = formatKpi
                                            //.toLocaleString(countrylocale.replace('_','-'));                     

                                        }
                                        data[getColumns[j][ns + 'Attribute_API_Name__c']] = decimal;
                                    } else {
                                        data[getColumns[j][ns + 'Attribute_API_Name__c']] = cellData;
                                    }

                                }
                            }
                            dataTable[i] = data;
                        }
                        //console.log(dataTable);
                        $scope.items = dataTable;
                        if ($scope.items[0] != null)
                            $scope.noRecondFoundColSPan = Object.values($scope.items[0]).length - 1;
                        else
                            $scope.noRecondFoundColSPan = 0;
                        $scope.updateFixCloumn();
                        $scope.$apply();
                        $('#selectAll')[0].checked = false;
                    }
                }

                function failure(error) {
                    console.log("oops something went wrong " + error);
                }
            }
            $scope.updateFixCloumn();
            //$scope.$apply();
        }

        function ReturnPositionType(relatedPositionType) {
            var PosType = '';
            if (relatedPositionType == 'Hybrid') {
                PosType = 'Base'
            } else {
                PosType = relatedPositionType;
            }
            return PosType;

        }
        // method to format date according to date format mentioned in custom setting
        function formatDate(date) {
            var d = new Date(date),
                month = '' + (d.getMonth() + 1),
                day = '' + d.getDate(),
                year = d.getFullYear();

            if (day.length == 1) {
                day = '0' + day;
            }
            if (month.length == 1) {
                month = '0' + month;
            }

            var updatedDate = dateString.replace(/d+|D+/, month).replace(/m+|M+/, day).replace(/y+|Y+/, year);

            if (updatedDate == '') {
                updatedDate = month + '/' + day + '/' + year;
            }
            return updatedDate;
        }
        window.selectGeosOnTableView = function() {
            var $scope = getScope('ARC');
            if ($scope.movementType == '{!$Label.ZIP}') {
                //Syncing between CIM Table and Table View 
                $scope.items.forEach(function(value, index) {
                    // child selection 

                    if (!$scope.selectedGeoRecords.has(value[$scope.geoNameAPIName])) {
                        //console.log(value[$scope.geoNameAPIName]);
                        $scope.items[index]['isChecked'] = false;
                    } else {
                        $scope.items[index]['isChecked'] = true;
                    }
                });
            }
        }
        window.selectAccountsOnTableView = function() {
            var $scope = getScope('ARC');
            if ($scope.movementType == '{!$Label.Account}') {
                //Syncing table view and CIM impact
                $scope.items.forEach(function(value, index) {


                    if (!$scope.selectedAccountRecords.has($scope.items[index][ns + 'Account__r.AccountNumber'])) {
                        $scope.items[index]['isChecked'] = false;
                    } else {
                        $scope.items[index]['isChecked'] = true;
                    }
                });
            }
        }
    </script>

</apex:component>
